'Entrez vos paramtres
API_USER = "API_USER"
API_SECRET = "API_SECRET"
PERIPH_ID = "ID DU TRACEUR GPS"
PERIPHDIST_ID = "ID DU MODULE ETAT"
USER_GOOGLE = "USER_GOOGLE"

'Entrez les coordonnes de votre domicile
LAT_MAISON = 48.606765
LONG_MAISON = 1.167048

'Entre les coorodnnes de votre lieu de travail (si vous souhaitez pouvoir l utiliser)
LAT_TRAVAIL = 49.817394
LONG_TRAVAIL = 2.959

Dim xmlHTTP
Set xmlHTTP = CreateObject("Microsoft.XMLHTTP")

' On rcupre les coordonnes sur Google Latitude
sSource = "https://www.google.com/latitude/apps/badge/api?user=" & USER_GOOGLE & "&type=atom"
bGetAsAsync = False
xmlHTTP.Open "GET", sSource, bGetAsAsync
xmlHTTP.Send
sHTMLPage = xmlHTTP.responseText
debut = InStr(sHTMLPage, "<georss:point>")
fin = InStr(sHTMLPage, "</georss:point>")
coordonnes = Mid(sHTMLPage, debut+14, fin-(debut+14))
coordonnes = Replace(coordonnes, chr(32), ",")

coordonnes2 = split(coordonnes, ",")
coordonnes2(0) = CDbl(replace(coordonnes2(0), ".", ","))
coordonnes2(1) = CDbl(replace(coordonnes2(1), ".", ","))

'Calcul de la distance de la maison
a = 3.1415926535 / 180
lat1 = LAT_MAISON * a
lat2 = coordonnes2(0) * a
lon1 = LONG_MAISON * a
lon2 = coordonnes2(1) * a

t1 = sin(lat1) * sin(lat2) 
t2 = cos(lat1) * cos(lat2)
t3 = cos(lon1 - lon2)
t4 = t2 * t3
t5 = t1 + t4

rad_dist = atn(-t5/sqr(-t5 * t5 +1)) + 2 * atn(1)  

distance_maison = (rad_dist * 3437.74677 * 1.1508) * 1.6093470878864446

'Calcul de la distance du travail
lat1 = LAT_TRAVAIL * a
lon1 = LONG_TRAVAIL * a

t1 = sin(lat1) * sin(lat2) 
t2 = cos(lat1) * cos(lat2)
t3 = cos(lon1 - lon2)
t4 = t2 * t3
t5 = t1 + t4
rad_dist = atn(-t5/sqr(-t5 * t5 +1)) + 2 * atn(1)  

distance_travail = (rad_dist * 3437.74677 * 1.1508) * 1.6093470878864446

'on dtermine l etat en fonction de la distance: si la distance est infrieure a 500m de la maison, on considre qu'on y est, idem pour le travail. La prcision peut tre ajuste selon les besoins.
if distance_maison < 0.500 then
etat = 0
elseif distance_travail < 0.500 then
etat = 1
else
etat = 2
end if

'Envoi de l tat de sa position
sTarget = "http://api.eedomus.com/set?action=periph.value&periph_id=" & PERIPHDIST_ID & "&value="& etat & "&api_user=" & API_USER & "&api_secret=" & API_SECRET
xmlHTTP.Open "GET", sTarget, bGetAsAsync
xmlHTTP.Send

' On envoie les infos  eedomus pour la carte
sTarget = "http://api.eedomus.com/set?action=periph.value&periph_id=" & PERIPH_ID & "&value="& coordonnes & "&api_user=" & API_USER & "&api_secret=" & API_SECRET
xmlHTTP.Open "GET", sTarget, bGetAsAsync
xmlHTTP.Send
